#include <windows.h>

#include "dialog_config.hpp"

struct DialogTemplate {
	// ݒ肩^GCAX
	typedef DialogConfig::SizeT   SizeT;
	typedef DialogConfig::NameT   NameT;
	typedef DialogConfig::StringT StringT;

	virtual ~DialogTemplate() {}

	// f[^̏o
	// c ɕKvTCYZiAC̗\]ɉZ邱Ƃj
	// p == 0 Ȃf[^͏Ȃ
	virtual void Write(BYTE* &p, SizeT &c) = 0;

	// obt@óTCYvZp wp֐

	// 1oCgo
	static inline void WriteByte(BYTE* &p, SizeT &c, BYTE v) {
		c++;
		if (p) *p++ = v;
	}
	// 2oCgo
	static inline void WriteWord(BYTE* &p, SizeT &c, WORD v) {
		c += 2;
		if (p) {
			*p++ = (BYTE)( v     & 0xFF);
			*p++ = (BYTE)((v>>8) & 0xFF);
		}
	}
	// 4oCgo
	static inline void WriteDWord(BYTE* &p, SizeT &c, DWORD v) {
		c += 4;
		if (p) {
			*p++ = (BYTE)( v      & 0xFF);
			*p++ = (BYTE)((v>> 8) & 0xFF);
			*p++ = (BYTE)((v>>16) & 0xFF);
			*p++ = (BYTE)((v>>24) & 0xFF);
		}
	}

	// 񏑂o
	static inline void WriteString(BYTE* &p, SizeT &c, NameT r) {
		while (*r) WriteWord(p, c, *r++);
		/**/       WriteWord(p, c, 0);
	}

	// ACg
	static inline void Alignment(BYTE* &p, SizeT &c, SizeT al) {
		c += al; // 傫ɂ͖Ȃ̂ŃTCYvZpɂ̓AC𑫂
		if (p) {
			ULONG n = al-1;
			p = (BYTE*) (((ULONG)p + n) & ~n);
		}
	}

	// sz_Or_Ord ^FID̂ǂ炩
	//  0x0000 : vfȂ
	//  0xFFFF 0x???? : ID
	//  ̑ : NullŏIUnicode

	typedef enum { SZORD_NONE, SZORD_ID, SZORD_STR } SZORD;
	struct sz_Or_Ord{
		SZORD sel;
		WORD id;
		StringT str;
		sz_Or_Ord() : sel(SZORD_NONE) {}
		inline void SetString(NameT s) { sel = SZORD_STR; str = s; }
		inline void SetID(WORD n)      { sel = SZORD_ID;  id  = n; }
		inline void Write(BYTE* &p, SizeT &c) {
			switch (sel) {
			case SZORD_ID:  WriteWord(  p, c, 0xFFFF); WriteWord(p, c, id); break;
			case SZORD_STR: WriteString(p, c, str.c_str()); break;
			default:        WriteWord(  p, c, 0); break;
			}
		}
	};
};

struct DialogHeader : public DialogTemplate {
	// DLGTEMPLATEEX; // zu͕K DWORD AĈ
	WORD dlgVer;			// o[Wi1j
	WORD signature;			// VOl`i0xFFFFj
	DWORD helpID;			// ReLXgwvID
	DWORD exStyle;			// exX^C
	DWORD style;			// X^C
	WORD dlgItems;			// ACě
	short x;				// x (dialog unit)
	short y;				// y (dialog unit)
	short cx;				// w (dialog unit)
	short cy;				// h (dialog unit)

	sz_Or_Ord menu;			// j[ID
	sz_Or_Ord windowClass;	// EBhENX
	StringT title;			// _CAO{bNX̃^Cg(Unicode)

	// ȉ DS_SETFONT w肳ꂽꍇ̂ݑ
	short pointSize;		// tHg̃TCY
	short weight;			// tHg̃EFCg(0`1000)
	BYTE  italic;			// tHg̃C^bN(TRUEorFALSE)
	BYTE  charset;			// tHg̃LZbg
	StringT typeFace;		// tHg̃^CvtFCX

	// l
	DialogHeader()
		:   dlgVer(1),
			signature(0xFFFF),
			helpID(0),
			exStyle(0),
			style(0),
			dlgItems(0),
			x(0),
			y(0),
			cx(0),
			cy(0),
			pointSize(0),
			weight(0),
			italic(0),
			charset(0)
		{}

	// o
	void Write(BYTE* &p, SizeT &c) {
		Alignment( p, c, 4);

		WriteWord( p, c, dlgVer);
		WriteWord( p, c, signature);
		WriteDWord(p, c, helpID);
		WriteDWord(p, c, exStyle);
		WriteDWord(p, c, style);
		WriteWord( p, c, dlgItems);
		WriteWord( p, c, (WORD)x);
		WriteWord( p, c, (WORD)y);
		WriteWord( p, c, (WORD)cx);
		WriteWord( p, c, (WORD)cy);
		menu       .Write(p, c);
		windowClass.Write(p, c);
		WriteString(p, c, title.c_str());

		if (style & DS_SETFONT) {
			WriteWord( p, c, (WORD)pointSize);
			WriteWord( p, c, (WORD)weight);
			WriteByte( p, c, (BYTE)italic);
			WriteByte( p, c, (BYTE)charset);
			WriteString(p, c, typeFace.c_str());
		}
	}
};

struct DialogItems : public DialogTemplate {
	// DLGITEMTEMPLATEEX; // zu͕K DWORD AĈ
	DWORD helpID;			// ReLXgwvID
	DWORD exStyle;			// exX^C
	DWORD style;			// X^C
	short x;				// x (dialog unit)
	short y;				// y (dialog unit)
	short cx;				// w (dialog unit)
	short cy;				// h (dialog unit)
	DWORD id;				// ̃Rg[ID

	sz_Or_Ord windowClass;	// EBhENX
	sz_Or_Ord title;		// ^Cg
	WORD extraCount;		// gf[^̃TCYiWORDACj
	BYTE const *extraData;

	DialogItems()
		:   helpID(0),
			exStyle(0),
			style(0),
			x(0),
			y(0),
			cx(0),
			cy(0),
			id(0),
			extraCount(0),
			extraData(0)
		{}

	// o
	void Write(BYTE* &p, SizeT &c) {
		Alignment( p, c, 4);

		WriteDWord(p, c, helpID);
		WriteDWord(p, c, exStyle);
		WriteDWord(p, c, style);
		WriteWord( p, c, (WORD)x);
		WriteWord( p, c, (WORD)y);
		WriteWord( p, c, (WORD)cx);
		WriteWord( p, c, (WORD)cy);
		WriteDWord(p, c, id);
		windowClass.Write(p, c);
		title      .Write(p, c);
		WriteWord(p, c, extraCount);
		if (extraCount > 0) {
			BYTE const *r = extraData;
			for (long i = 0; i < (long)extraCount; i++)
				WriteByte(p, c, *r++);

			Alignment( p, c, 2);
		}
	}
};

